diff --git a/channels/chan_iax2.c b/channels/chan_iax2.c
index 67552ce4e6..94f9649f2a 100644
--- a/channels/chan_iax2.c
+++ b/channels/chan_iax2.c
@@ -13092,6 +13092,9 @@ static struct iax2_peer *build_peer(const char *name, struct ast_variable *v, st
 			/* The MWI subscriptions exist just so the core knows we care about those
 			 * mailboxes.  However, we just grab the events out of the cache when it
 			 * is time to send MWI, since it is only sent with a REGACK. */
+			if (found && peer->mwi_event_sub) {
+				stasis_unsubscribe(peer->mwi_event_sub);
+			}
 			peer->mwi_event_sub = stasis_subscribe_pool(mailbox_specific_topic, stasis_subscription_cb_noop, NULL);
 		}
 	}
